

#region Using declarations
using System;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using System.Xml.Serialization;
//using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;

#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// 
    /// </summary>
    [Description("")]
    [Gui.Design.DisplayName("CycleIdentifier")]
    public class CycleIdentifier : Indicator
    {

		#region Variables
        // Wizard generated variables
		private int       pPriceActionFilter=1;
		private int       pLength=3;
		private int       pMajorCycleStrength=4;
		private bool      pUseCycleFilter=false;
		private int       pUseFilterSMAorRSI=1;
		private int       pFilterStrengthSMA=12;
		private int       pFilterStrengthRSI=21;
		private DataSeries ZL1, CyclePrice;
		
		private double Strength =0.0, SweepA = 0.0, SweepB = 0.0;
		private int Switch = 0, Switch2 = 0,SwitchA = 0, SwitchB = 0, SwitchC = 0, SwitchD = 0, SwitchE = 0, SwitchAA = 0, SwitchBB = 0;
		private double Price1BuyA = 0.0, Price2BuyA = 0.0;
		private int Price1BuyB = 1, Price2BuyB = 1;
		private double Price1SellA = 0.0, Price2SellA = 0.0;
		private int Price1SellB = 0, Price2SellB = 0;
		private bool ActiveSwitch = true, BuySwitchA = false, BuySwitchB = false, SellSwitchA = false, SellSwitchB = false;
		private int BuySellFac = 01;
		private double PanelMax = 1.2, PanelMin=-1.2;
		private bool Condition1, Condition2, Condition3, Condition6, RunInit=true;
		#endregion

		/// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(new Pen(Color.DarkGray,1), PlotStyle.Line, "Line"));
            Add(new Plot(new Pen(Color.Lime,2), PlotStyle.Bar, "MajorCycleBuy"));
            Add(new Plot(new Pen(Color.Red,2), PlotStyle.Bar, "MajorCycleSell"));
            Add(new Plot(new Pen(Color.DarkGreen,2), PlotStyle.Bar, "MinorCycleBuy"));
            Add(new Plot(new Pen(Color.Brown,2), PlotStyle.Bar, "MinorCycleSell"));
//            Add(new Plot(new Pen(Color.Transparent,2), PlotStyle.Dot, "Max"));
//            Add(new Plot(new Pen(Color.Transparent,2), PlotStyle.Dot, "Min"));
			Add(new Line(new Pen(Color.Gray,1),0,"Zero"));
			Add(new Line(new Pen(Color.Gray,1),1.2,"Max"));
			Add(new Line(new Pen(Color.Gray,1),-1.2,"Min"));
			CyclePrice = new DataSeries(this);
			ZL1 = new DataSeries(this);
            CalculateOnBarClose	= true;
            Overlay				= false;
            PriceTypeSupported	= false;
			RunInit = true;
		}

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			if(RunInit) {
				Lines[1].Pen.Color = ChartControl.BackColor;
				Lines[2].Pen.Color = ChartControl.BackColor;
				PanelMax = Lines[1].Value * 0.8;
				PanelMin = Lines[2].Value * 0.8;
				RunInit = false;
			}
			int rnglength = 250;
			if(CurrentBar<rnglength) return;
			double range = 0.0, srange = 0.0;
			int j=0;
			for (int i=0;i<rnglength;i++) {
				if(i>=CurrentBar) break;
				j++;
				srange = srange + (High[i] - Low[i]);
			}
			range = srange / j * pLength;
			CyclePrice.Set(SMA(Close, pPriceActionFilter)[0]);
			if (pUseFilterSMAorRSI == 1)
				ZL1.Set(ZeroLag(CyclePrice[0], pFilterStrengthSMA, 0));
			if (pUseFilterSMAorRSI == 2) {
				ZL1.Set(ZeroLag(RSI_DataSeriesInput(14,1,CyclePrice)[pFilterStrengthRSI], pFilterStrengthRSI, 0));
			}
			
			if (ZL1[0] > ZL1[1]) 
				SwitchC = 1;
			if (ZL1[0] < ZL1[1]) 
				SwitchC = 2;
          
			if (Strength == 0)
				SweepA = range;
			else
				SweepA = Strength;
			if (RunInit)
			{
				RunInit=false;
				Price1BuyA = CyclePrice[0];
				Price1SellA = CyclePrice[0];
			}

			if (Switch > -1)
			{
				if (CyclePrice[0] < Price1BuyA)
				{
					if (pUseCycleFilter && (SwitchC == 2) && BuySwitchA )
					{
						MinorCycleBuy.Set(CurrentBar - Price1BuyB, 0); //MinorBuySell
						TheLine.Set(CurrentBar - Price1BuyB, 0); //line
					}

					if (!pUseCycleFilter && BuySwitchA)
					{
						MinorCycleBuy.Set(CurrentBar - Price1BuyB, 0);
						TheLine.Set(CurrentBar - Price1BuyB, 0);
		            }
		            Price1BuyA = CyclePrice[0];
					Price1BuyB = CurrentBar;
					BuySwitchA = true;
				}
				else if (CyclePrice[0] > Price1BuyA)
				{
					SwitchA = CurrentBar - Price1BuyB;
         
					if (!pUseCycleFilter)
					{
			           MinorCycleBuy.Set(SwitchA, PanelMin);//MinorBuySell - DarkGreen
			           TheLine.Set(SwitchA, PanelMin);//line
		            }
		      
		            if (pUseCycleFilter && SwitchC  == 1)
		            {
						MinorCycleBuy.Set(SwitchA, PanelMin);  //MinorBuySell
						TheLine.Set(SwitchA, PanelMin); //line
						SwitchD = 1; 
					}
					else
			           SwitchD = 0;

					BuySwitchA = true;

					double cyclePrice1 = SMA(Close, pPriceActionFilter)[SwitchA];
					if (ActiveSwitch)
					{  
						Condition1 = CyclePrice[0] - cyclePrice1 >= SweepA; 
					}
					else
					{
						Condition1 = CyclePrice[0] >= cyclePrice1 * (1.0 + SweepA / 1000.0);
					}
					if (Condition1 && SwitchA >= BuySellFac) 
					{
						Switch =  -1;
						Price1SellA = CyclePrice[0];
						Price1SellB = CurrentBar;
						SellSwitchA = false;
						BuySwitchA = false;
					}            
				}
			}

			if(Switch < 1)
			{
				if (CyclePrice[0] > Price1SellA)
				{
					if (pUseCycleFilter && SwitchC == 1 && SellSwitchA )
					{
						MinorCycleSell.Set(CurrentBar - Price1SellB, 0); //MinorBuySell
						TheLine.Set(CurrentBar - Price1SellB, 0); //line
					}
					if (!pUseCycleFilter && SellSwitchA )
					{
						MinorCycleSell.Set(CurrentBar - Price1SellB, 0);//MinorBuySell
						TheLine.Set(CurrentBar - Price1SellB, 0);//line
					}
					Price1SellA = CyclePrice[0];
					Price1SellB = CurrentBar;
					SellSwitchA = true;
				}
				else if (CyclePrice[0] < Price1SellA)
				{
					SwitchA = CurrentBar - Price1SellB;
					if (!pUseCycleFilter)
					{
						MinorCycleSell.Set(SwitchA, PanelMax); // MinorBuySell darkRed
						TheLine.Set(SwitchA, PanelMax); //"CycleLine"
					}
					if (pUseCycleFilter && SwitchC == 2)
					{
						MinorCycleSell.Set(SwitchA, PanelMax);//MinorBuySell darkRed
						TheLine.Set(SwitchA, PanelMax);//CycleLine
						SwitchD = 2;
					}
					else
						SwitchD = 0;

					SellSwitchA = true;
					double cyclePrice2 = SMA(Close, pPriceActionFilter)[SwitchA];
               
					if (ActiveSwitch)
						Condition1 = (cyclePrice2 - CyclePrice[0]) >= SweepA;
					else 
						Condition1 = CyclePrice[0] <= (cyclePrice2 * (1.0 - SweepA / 1000.0));

					if (Condition1 && SwitchA >= BuySellFac)
					{
						Switch = 1;
						Price1BuyA = CyclePrice[0];
						Price1BuyB = CurrentBar;
						SellSwitchA = false;
						BuySwitchA = false;
					}
				} 
			}
		
		
		
			TheLine.Set(0);
			MinorCycleBuy.Set(0);
			MinorCycleSell.Set(0);

			if (Strength == 0)
				SweepB  = range *  pMajorCycleStrength;
			else
				SweepB = Strength * pMajorCycleStrength;
			if (CurrentBar == 1)
			{
				Price2BuyA = CyclePrice[0];
				Price2SellA = CyclePrice[0];
			}     
            
			if (CurrentBar > 1)
			{
				if (Switch2  >  - 1)
				{
					if (CyclePrice[0] < Price2BuyA)
					{
						if (pUseCycleFilter && SwitchC == 2 && BuySwitchB )
						{
							MajorCycleBuy.Set(CurrentBar - Price2BuyB, 0); //MajorBuySell,green
						}
						if (!pUseCycleFilter && BuySwitchB )
						{
							MajorCycleBuy.Set(CurrentBar - Price2BuyB, 0);//MajorBuySell,green
						}
						Price2BuyA = CyclePrice[0];
						Price2BuyB = CurrentBar;
						BuySwitchB = true;
					} 
					else if (CyclePrice[0] > Price2BuyA)
					{
						SwitchB = CurrentBar - Price2BuyB;
						if (!pUseCycleFilter)
						{  
							MajorCycleBuy.Set(SwitchB, PanelMin); //MajorBuySell green
						}
						if (pUseCycleFilter && SwitchC == 1)
						{
							MajorCycleBuy.Set(SwitchB, PanelMin); //MajorBuySell green
							SwitchE  = 1;
						} 
						else
							SwitchE  = 0;

						BuySwitchB = true;
						double cyclePrice3 = SMA(Close, pPriceActionFilter)[SwitchB];
						if (ActiveSwitch) 
							Condition6 = CyclePrice[0] - cyclePrice3 >= SweepB;
						else
							Condition6 = CyclePrice[0] >= cyclePrice3 * (1.0 + SweepB / 1000.0);

						if (Condition6 && SwitchB >= BuySellFac)
						{
							Switch2 =  -1;
							Price2SellA = CyclePrice[0];
							Price2SellB = CurrentBar;
							SellSwitchB = false;
							BuySwitchB = false;
						}
					}
				}

				if (Switch2  < 1)
				{
					if (CyclePrice[0]  > Price2SellA )
					{
						if (pUseCycleFilter && SwitchC  == 1 && SellSwitchB )
						{ 
							MajorCycleSell.Set(CurrentBar - Price2SellB, 0); //"MajorBuySell",red 
						}
						if (!pUseCycleFilter && SellSwitchB )
						{
							MajorCycleSell.Set(CurrentBar - Price2SellB, 0);//"MajorBuySell",red 
						}
						Price2SellA = CyclePrice[0];
						Price2SellB = CurrentBar;
						SellSwitchB = true;
					}
					else if (CyclePrice[0] < Price2SellA)
					{
						SwitchB = CurrentBar - Price2SellB ;

						if (!pUseCycleFilter) 
						{
							MajorCycleSell.Set(SwitchB, PanelMax); //"MajorBuySell",red 
						}
						if (pUseCycleFilter && SwitchC  == 2)
						{
							MajorCycleSell.Set(SwitchB, PanelMax); //"MajorBuySell",red 
							SwitchE  = 2;
						}
						else
							SwitchE  = 0;

						SellSwitchB = true;
						double cyclePrice4 = SMA(Close, pPriceActionFilter)[SwitchB];
						if (ActiveSwitch)
							Condition6 = cyclePrice4 - CyclePrice[0] >= SweepB;
						else
							Condition6 = CyclePrice[0] <= cyclePrice4 * (1.0 - SweepB / 1000.0);

						if (Condition6 && SwitchB >= BuySellFac)
						{
							Switch2 = 1;
							Price2BuyA = CyclePrice[0];
							Price2BuyB = CurrentBar;
							SellSwitchB = false;
							BuySwitchB = false;
						}
					}
				}
			}
			TheLine.Set(0);
			MajorCycleSell.Set(0);
			MajorCycleBuy.Set(0);
		}
	private double ZeroLag(double price, int length, int pos)
	{   
		if (length < 3)
			return(price);
		double aa = Math.Exp(-1.414*3.14159 / length);
		double bb = 2*aa*Math.Cos(1.414*180 / length);
		double CB = bb;
		double CC = -aa*aa;
		double CA = 1 - CB - CC;
		double CD = CA*price + CB*ZL1[pos+1] + CC*ZL1[pos+2];
		return(CD);
	}


        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries TheLine
        {
            get { return Values[0]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries MajorCycleBuy
        {
            get { return Values[1]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries MajorCycleSell
        {
            get { return Values[2]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries MinorCycleBuy
        {
            get { return Values[3]; }
        }
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries MinorCycleSell
        {
            get { return Values[4]; }
        }

        [Description("")]
        [Category("Parameters")]
        public int Length
        {
            get { return pLength; }
            set { pLength = value; }
        }
        [Description("")]
        [Category("Parameters")]
        public int MajorCycleStrength
        {
            get { return pMajorCycleStrength; }
            set { pMajorCycleStrength = value; }
        }
        [Description("")]
        [Category("Parameters")]
        public int FilterStrengthSMA
        {
            get { return pFilterStrengthSMA; }
            set { pFilterStrengthSMA = value; }
        }
        [Description("")]
        [Category("Parameters")]
        public int FilterStrengthRSI
        {
            get { return pFilterStrengthRSI; }
            set { pFilterStrengthRSI = value; }
        }
        [Description("")]
        [Category("Parameters")]
        public int PriceActionFilter
        {
            get { return pPriceActionFilter; }
            set { pPriceActionFilter = value; }
        }
        [Description("")]
        [Category("Parameters")]
        public int UseFilterSMAorRSI
        {
            get { return pUseFilterSMAorRSI; }
            set { pUseFilterSMAorRSI = value; }
        }
        [Description("")]
        [Category("Parameters")]
        public bool UseCycleFilter
        {
            get { return pUseCycleFilter; }
            set { pUseCycleFilter = value; }
        }

		#endregion
    }
}


#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private CycleIdentifier[] cacheCycleIdentifier = null;

        private static CycleIdentifier checkCycleIdentifier = new CycleIdentifier();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public CycleIdentifier CycleIdentifier(int filterStrengthRSI, int filterStrengthSMA, int length, int majorCycleStrength, int priceActionFilter, bool useCycleFilter, int useFilterSMAorRSI)
        {
            return CycleIdentifier(Input, filterStrengthRSI, filterStrengthSMA, length, majorCycleStrength, priceActionFilter, useCycleFilter, useFilterSMAorRSI);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public CycleIdentifier CycleIdentifier(Data.IDataSeries input, int filterStrengthRSI, int filterStrengthSMA, int length, int majorCycleStrength, int priceActionFilter, bool useCycleFilter, int useFilterSMAorRSI)
        {
            checkCycleIdentifier.FilterStrengthRSI = filterStrengthRSI;
            filterStrengthRSI = checkCycleIdentifier.FilterStrengthRSI;
            checkCycleIdentifier.FilterStrengthSMA = filterStrengthSMA;
            filterStrengthSMA = checkCycleIdentifier.FilterStrengthSMA;
            checkCycleIdentifier.Length = length;
            length = checkCycleIdentifier.Length;
            checkCycleIdentifier.MajorCycleStrength = majorCycleStrength;
            majorCycleStrength = checkCycleIdentifier.MajorCycleStrength;
            checkCycleIdentifier.PriceActionFilter = priceActionFilter;
            priceActionFilter = checkCycleIdentifier.PriceActionFilter;
            checkCycleIdentifier.UseCycleFilter = useCycleFilter;
            useCycleFilter = checkCycleIdentifier.UseCycleFilter;
            checkCycleIdentifier.UseFilterSMAorRSI = useFilterSMAorRSI;
            useFilterSMAorRSI = checkCycleIdentifier.UseFilterSMAorRSI;

            if (cacheCycleIdentifier != null)
                for (int idx = 0; idx < cacheCycleIdentifier.Length; idx++)
                    if (cacheCycleIdentifier[idx].FilterStrengthRSI == filterStrengthRSI && cacheCycleIdentifier[idx].FilterStrengthSMA == filterStrengthSMA && cacheCycleIdentifier[idx].Length == length && cacheCycleIdentifier[idx].MajorCycleStrength == majorCycleStrength && cacheCycleIdentifier[idx].PriceActionFilter == priceActionFilter && cacheCycleIdentifier[idx].UseCycleFilter == useCycleFilter && cacheCycleIdentifier[idx].UseFilterSMAorRSI == useFilterSMAorRSI && cacheCycleIdentifier[idx].EqualsInput(input))
                        return cacheCycleIdentifier[idx];

            CycleIdentifier indicator = new CycleIdentifier();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.FilterStrengthRSI = filterStrengthRSI;
            indicator.FilterStrengthSMA = filterStrengthSMA;
            indicator.Length = length;
            indicator.MajorCycleStrength = majorCycleStrength;
            indicator.PriceActionFilter = priceActionFilter;
            indicator.UseCycleFilter = useCycleFilter;
            indicator.UseFilterSMAorRSI = useFilterSMAorRSI;
            indicator.SetUp();

            CycleIdentifier[] tmp = new CycleIdentifier[cacheCycleIdentifier == null ? 1 : cacheCycleIdentifier.Length + 1];
            if (cacheCycleIdentifier != null)
                cacheCycleIdentifier.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheCycleIdentifier = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.CycleIdentifier CycleIdentifier(int filterStrengthRSI, int filterStrengthSMA, int length, int majorCycleStrength, int priceActionFilter, bool useCycleFilter, int useFilterSMAorRSI)
        {
            return _indicator.CycleIdentifier(Input, filterStrengthRSI, filterStrengthSMA, length, majorCycleStrength, priceActionFilter, useCycleFilter, useFilterSMAorRSI);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.CycleIdentifier CycleIdentifier(Data.IDataSeries input, int filterStrengthRSI, int filterStrengthSMA, int length, int majorCycleStrength, int priceActionFilter, bool useCycleFilter, int useFilterSMAorRSI)
        {
            return _indicator.CycleIdentifier(input, filterStrengthRSI, filterStrengthSMA, length, majorCycleStrength, priceActionFilter, useCycleFilter, useFilterSMAorRSI);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.CycleIdentifier CycleIdentifier(int filterStrengthRSI, int filterStrengthSMA, int length, int majorCycleStrength, int priceActionFilter, bool useCycleFilter, int useFilterSMAorRSI)
        {
            return _indicator.CycleIdentifier(Input, filterStrengthRSI, filterStrengthSMA, length, majorCycleStrength, priceActionFilter, useCycleFilter, useFilterSMAorRSI);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public Indicator.CycleIdentifier CycleIdentifier(Data.IDataSeries input, int filterStrengthRSI, int filterStrengthSMA, int length, int majorCycleStrength, int priceActionFilter, bool useCycleFilter, int useFilterSMAorRSI)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.CycleIdentifier(input, filterStrengthRSI, filterStrengthSMA, length, majorCycleStrength, priceActionFilter, useCycleFilter, useFilterSMAorRSI);
        }

    }
}
#endregion
